package mvd.jester.simulator;

import mvd.jester.model.SystemSetup;
import mvd.jester.model.Task;
import mvd.jester.simulator.internals.maiabertogna.TaskContext;

/**
 * MaiaBertogna
 */
public class MaiaBertogna extends AbstractSimulator {

    public MaiaBertogna(SystemSetup systemSetup) {
        super(systemSetup);
    }

    @Override
    protected boolean releaseTasks(long timeStep) {
        for (Task t : systemSetup.getTasks()) {
            if (timeStep % t.getPeriod() == 0) {
                if (!readyTasks.add(new TaskContext(t, timeStep))) {
                    return false;
                }
            }
        }
        return true;
    }

    @Override
    public String getName() {
        return "MaiaBertogna";
    }


}
